package ru.dbotthepony.kbox2d.dynamics.contact

import ru.dbotthepony.kbox2d.api.IShape
import ru.dbotthepony.kbox2d.api.Manifold
import ru.dbotthepony.kbox2d.api.Transform
import ru.dbotthepony.kbox2d.collision.handler.b2CollideEdgeAndCircle
import ru.dbotthepony.kbox2d.collision.shapes.ChainShape
import ru.dbotthepony.kbox2d.collision.shapes.CircleShape
import ru.dbotthepony.kbox2d.dynamics.B2Fixture

class ChainCircleContact(
	fixtureA: B2Fixture,
	childIndexA: Int,
	fixtureB: B2Fixture,
	childIndexB: Int,
) : AbstractContact(fixtureA, childIndexA, fixtureB, childIndexB) {
	init {
		require(fixtureA.type == IShape.Type.CHAIN) { "Fixture A is of type ${fixtureA.type}" }
		require(fixtureB.type == IShape.Type.CIRCLE) { "Fixture B is of type ${fixtureB.type}" }
	}

	override fun evaluate(xfA: Transform, xfB: Transform): Manifold {
		val chain = fixtureA.shape as ChainShape
		val edge = chain.getChildEdge(childIndexA)

		return b2CollideEdgeAndCircle(edge, xfA, fixtureB.shape as CircleShape, xfB)
	}
}
