package ru.dbotthepony.kbox2d.dynamics.contact

import ru.dbotthepony.kbox2d.api.IShape
import ru.dbotthepony.kbox2d.api.Manifold
import ru.dbotthepony.kbox2d.api.Transform
import ru.dbotthepony.kbox2d.collision.handler.b2CollideCircles
import ru.dbotthepony.kbox2d.collision.shapes.CircleShape
import ru.dbotthepony.kbox2d.dynamics.B2Fixture

class CircleContact(
	fixtureA: B2Fixture,
	fixtureB: B2Fixture,
) : AbstractContact(fixtureA, 0, fixtureB, 0) {
	init {
		require(fixtureA.type == IShape.Type.CIRCLE) { "Fixture A is of type ${fixtureA.type}" }
		require(fixtureB.type == IShape.Type.CIRCLE) { "Fixture B is of type ${fixtureB.type}" }
	}

	override fun evaluate(xfA: Transform, xfB: Transform): Manifold {
		return b2CollideCircles(fixtureA.shape as CircleShape, xfA, fixtureB.shape as CircleShape, xfB)
	}
}
